function [om]=mix(data,iv,indi,al,be,mu,ga,la,df)

%One draw of the mixing parameters

dimd=size(data); tt=dimd(1); nvar=dimd(2);
dimi=size(indi); nclus=dimi(2);
tim=sum(1-isnan(data)); nobs=sum(tim);
dimb=size(be); runb=dimb(1); nvb=dimb(2);
runa=size(al,1); nkal=size(al,2);
runm=size(mu,1); nkmu=size(mu,2); ncmu=size(mu,3);
niv=size(iv,1); miv=size(iv,3); 

if ~isequal(nkal,nkmu,nclus)
    disp([nkal nkmu nclus])
    error('Clusters and parameters must agree')
end

ca=al(runa,:); cl=la(length(la)); cg=ga(length(ga));
cb=be(runb,:); cn=df(length(df)); cm=squeeze(mu(runm,:,:));

if isequal(nvar,nvb,dimi(1),miv)<1
    disp([nvar,nvb,dimi(1),miv])
    error('The dimension of beta or indi is not right')
end
if ~isequal(niv,ncmu)
    error('Number of covariates and parameter dimension must agree')
end


om=NaN(dimd);
aa=(cn+1)/2;
ca=indi*ca';

if niv==1
    cm=indi*cm';
else
    cm=indi*cm;
end


if isequal(nobs,tt*nvar)
    dat0=[zeros(1,nvar);data(1:tt-1,:)];
    cma=ones(tt,1)*ca';
    reg=NaN(tt,nvar);
    for i=1:nvar
        reg(:,i)=(cm(i,:)*squeeze(iv(:,:,i)))';
    end
    ker=data - cma.*dat0 - (ones(tt,1)*cb).*(1-cma) - reg.*(1-cma);
    scl=(ker<=0)*cg + (ker>0)/cg;
    bb=0.5*(cn + cl*(ker.*scl).^2);
    om=gamrnd(aa,1./bb);

else
    for i=1:nvar
        loni=tim(i);
        whos=find(1-isnan(data(:,i)));
        dati=data(whos,i);
        dat0=[0;dati(1:loni-1)];
        ker=dati-ca(i)*dat0-cb(i)*(1-ca(i)) - (((1-ca(i))*cm(i,:))*squeeze(iv(:,whos,i)))';
        scl=(ker<=0)*cg+(ker>0)/cg;
        bb=0.5*(cn + cl*(ker.*scl).^2);
        om(whos,i)=gamrnd(aa,1./bb);
    end
end