function [aas acc]=naas(mu,aas,csq,hmas,baas,acc)

%Draws a new vector of covariances

if length(size(mu))<3
    pcov=1;
else
    pcov=size(mu,3);
end
if baas<=1
    error('Proposal parameter must be greater than one')
end

kmu=size(mu,2); rmu=size(mu,1);
paas=size(aas,2); ruaas=size(aas,1);
khma=size(hmas,1);

caas=aas(ruaas,:);

if ~isequal(kmu,khma)
    error('Hyper means and length of coef must agree')
end
if ~isequal(paas,pcov)
    error('Number of covs and covas must agree')
end
cm=reshape(squeeze(mu(rmu,:,:)),kmu,pcov);
new=NaN(1,pcov);
aca=NaN(1,pcov);

   
for l=1:pcov
    comas=csq*((1-caas(l))*eye(kmu) + caas(l)*ones(kmu,kmu));
    astar=2-baas + (kmu*(1-baas))/((kmu-1)*(caas(l)-1));
    if astar<=1
        disp([astar baas])
        disp(caas)
        error('For the mode to exist, a>1')
    end
    propa=(kmu*betarnd(astar,baas)-1)/(kmu-1);
    rasta=2-baas + (kmu*(1-baas))/((kmu-1)*(propa-1));
    pisig=eye(kmu)/(csq*((1-propa)*eye(kmu)+ propa*ones(kmu,kmu)));
    mhr=pdf_mvn(cm(:,l),hmas(:,l), pisig,2) - pdf_mvn(cm(:,l),hmas(:,l),comas,1) -...
        pdf_rebe(propa,astar,rasta,kmu) + pdf_rebe(caas(l),astar,baas,kmu);
    crit=min(0,mhr);
    comp=log(rand);
    chg=(crit>=comp);
    new(l)=(propa*chg) + caas(l)*(1-chg);
    aca(l)=chg;
end
aas=[caas;new];
acc=acc+aca;