function [mu acc]=new_coeff(data,iv,indi,al,be,mu,ga,la,om,hymm,csq,aas,prec,acc)

%Draws a new coefficient matrix

preg=size(iv,1); mreg=size(iv,3);
chk=length(size(mu));
if chk==2 
    if preg>1
        error('Number of covariates and coefficients must agree')
    else
        ncmu=1; runm=size(mu,1); nkmu=size(mu,2);
    end
else
    ncmu=size(mu,3); runm=size(mu,1); nkmu=size(mu,2);
end
if csq<0
    error('Hyper C must be positive')
end
nphm=size(hymm,1); npht=size(aas,2);
nvar=size(data,2); runaas=size(aas,1);
nclus=size(indi,2); mclus=size(indi,1);

if ~isequal(mclus,nvar)
    disp([mclus; nvar])
    error('Units and indicator must be consistent')
end

dima=size(al); runa=dima(1);
if ~isequal(ncmu,preg)
    error('Clusters and dynamics must be consistent')
end
runb=size(be,1);

if ~isequal(size(be,2),mreg,nvar)
    error('Location and units must be consistent')
end

if ~isequal(nclus,nkmu,dima(2),nphm)
    disp([nclus,nkmu,dima(2), nphm])
    error('Hyperparameters and clusters must be consistent')
end

if ~isequal(npht, preg,ncmu)
    error('Dimension on regressor coefficients must agree')
end

pos=indi*(1:nclus)';

ca=al(runa,:); cb=be(runb,:); cg=ga(length(ga)); cm=reshape(squeeze(mu(runm,:,:)),nclus,preg);
cl=la(length(la));

tempa=NaN(nclus,preg); tempc=zeros(1,nclus); prop=NaN(nclus,preg);

for j=1:nclus
    if ncmu==1 
        cmj=cm(j); 
    else
        cmj=cm(j,:); 
    end
    prop(j,:)= cmj + prec(j)^(-0.5)*trnd(3,1,preg);
end


pripo=sum(pri_mu(prop,hymm,aas,csq));
priol=sum(pri_mu(cm,hymm,aas,csq));

for j=1:nclus
    caj=ca(j);   memb=find(pos==j); 
    if ncmu==1 
        cmj=cm(j); 
    else
        cmj=cm(j,:); 
    end
    datj=data(:,memb);  omj=om(:,memb); bej=cb(memb); ivj=iv(:,:,memb);
    mera=pdf_mu(datj,ivj,caj,bej,prop(j,:),cg,cl,omj,pripo);
    mina=pdf_mu(datj,ivj,caj,bej,cmj,cg,cl,omj,priol);
    [tempa(j,:) tempc(j)]=nmu(mera,mina,prop(j,:),cmj);
end

mu(1,:,:)=cm; mu(2,:,:)=tempa;
acc=acc+tempc;
