function [al acc]=new_dynamics(data,iv,indi,al,be,mu,ga,la,om,aal,bal,pa,acc)

%Draws a new dynamics vector

dimd=size(data); nvar=dimd(2);
dimi=size(indi); nclus=dimi(2);
ncov=size(iv,1);

if dimi(1)~=nvar
    error('Units and indicator must be consistent')
end

dima=size(al); runa=dima(1);
if dima(2)~=nclus
    error('Clusters and dynamics must be consistent')
end
runb=size(be,1);
if size(be,2)~=nvar
    error('Location and units must be consistent')
end

runaa=size(aal,1); runab=size(bal,1);
dimm=size(mu); runm=dimm(1);

if ~isequal(size(aal,2), size(bal,2), nclus)
    error('Hyperparameters and clusters must be consistent')
end

pos=indi*(1:nclus)';

ca=al(runa,:); cb=be(runb,:); cg=ga(length(ga));  cm=squeeze(mu(runm,:,:));
cl=la(length(la)); caa=aal(runaa,:); cba=bal(runab,:);
tempa=NaN(1,nclus); tempc=zeros(1,nclus);

for j=1:nclus
    caj=ca(j); caaj=caa(j); cbaj=cba(j);
    memb=find(pos==j); 
    if ncov==1 
        cmj=cm(j); 
    else
        cmj=cm(j,:); 
    end
    datj=data(:,memb);  omj=om(:,memb); bej=cb(memb); ivj=iv(:,:,memb);
    [tempa(j) tempc(j)]=nal(datj,ivj,caj,bej,cmj,cg,cl,omj,caaj,cbaj,pa(j));
end

al=[ca;tempa];
acc=acc+tempc;