function p = pdf_mvn(x,mu,sigma,ind)

%log pdf of a multivariate normal, 1 if using cov matrix nought for prec

if length(x)==length(mu)
    dim=length(x);
else
    disp(size(x))
    disp(size(mu))
    error('Dimensions must agree')
end
if nargin<4
    ind=1;
end

x=reshape(x,1,dim);
mu=reshape(mu,1,dim);

if ind==1
    prec=eye(dim)/sigma;
    p= 0.5*log(det(prec)) -dim/2*log(2*pi) - 0.5*(x-mu)*prec*(x-mu)';
else
    p= 0.5*log(det(sigma)) -dim/2*log(2*pi) - 0.5*(x-mu)*sigma*(x-mu)';
end