% function p = pdf_mvnct(x,mu,sigma,df)
% 
% %log pdf of a multivariate student distribution
% 
% if length(x)==length(mu)
%     dim=length(x);
% else
%     error('Dimension of argument and mean must agree')
% end
% 
% x=reshape(x,1,dim);
% mu=reshape(mu,1,dim);
% 
% prec= eye(dim)/sigma;
% 
% p = gammaln(0.5*(df+dim))- gammaln(0.5*df) - dim/2*log(df*pi)-0.5*log(det(prec)) - (dim + df)/2 * log(1 + (x-mu)*prec*(x-mu)'/df);
% 

function p = pdf_mvnct(x,mu,sigma,df)

%log pdf of a multivariate student distribution

if size(x,2)>0
    lx=size(x,2);
    sx=size(x,1);
else
    lx=length(x);
    sx=1;
end
    
if lx==length(mu)
    dim=lx;
else
    disp([lx sx length(mu)])
    error('Dimension of argument and mean must agree')
end

mu=reshape(mu,1,dim);
p=NaN(sx,1);

prec= eye(dim)/sigma;

for k=1:sx
    p(k)=log(1 + (x(k,:)-mu)*prec*(x(k,:)-mu)'/df);
end

p = gammaln(0.5*(df+dim))- gammaln(0.5*df) - dim/2*log(df*pi)-0.5*log(det(prec)) - (dim + df)/2 * p;