function p = pri_nu(nu,m,ind)

%log pdf of the prior for the degrees of freedom. 1 for gamma, 2 for gamma-gamma and three for Jeffreys

if nargin<3
    error('must specify which prior to use')
end

if ind==1
    p=pdf_gd(nu,2,0.1);

elseif ind==2
    p = log(2*m) + log(nu) -3*log(nu+m);

elseif ind==3
    p=0.5*log(nu./(nu+3)) + 0.5*log(psi(1,nu/2) - psi(1,(nu+1)/2) - 2*(nu+3)./(nu.*(nu+1).^2));

else
    error('indicate either of three available options')
end