function [p]=prupdate(data,iv,al,be,mu,ga,la,nu,eta)

%Calculates the cluster probabilities

tt=size(data,1); nvar=size(data,2);
efsi=sum(1-isnan(data)); nobs=sum(efsi);
nclus=size(al,2); runa=size(al,1);
runb=size(be,1); nbes=size(be,2);
runp=size(eta,1); nps=size(eta,2);
niv=size(iv,1); miv=size(iv,3);
runm=size(mu,1); nkmu=size(mu,2); ncmu=size(mu,3);

if ~isequal(nbes,nvar,miv)
    error('Check number of intercepts and coefficients') 
end
if nps~=nclus 
    error('Check probs and clusters') 
end
if ncmu~=niv || nkmu~=nclus
    error('Coefficient vector is not right')
end

ca=al(runa,:); cb=be(runb,:); cg=ga(length(ga)); cm=squeeze(mu(runm,:,:));
cl=la(length(la)); cn=nu(length(nu)); cp=eta(runp,:);

if sum(cp)~=1
    cp=cp/sum(cp);
end

p=NaN(nvar,nclus);

if isequal(nobs,tt*nvar)
    dat0=[zeros(1,nvar);data(1:tt-1,:)];
    for m=1:nvar
        for j=1:nclus
            if niv==1
                cmj=cm(j);
            else
                cmj=cm(j,:);
            end
            ker=data(:,m) - cb(m)*(1-ca(j)) - ca(j)*dat0(:,m) - ((1-ca(j))*cmj*squeeze(iv(:,:,m)))';
            p(m,j)=cp(j)*prod(skt(ker,cg,cl,cn));
        end
    end
else
    for m=1:nvar
        tm=efsi(m);
        whos=find(1-isnan(data(:,m)));
        datm=data(whos,m);
        dat0=[0;datm(1:tm-1)];
        ivm=squeeze(iv(:,whos,m));
        for j=1:nclus
            if niv==1
                cmj=cm(j);
            else
                cmj=cm(j,:);
            end
            ker= datm -cb(m)*(1-ca(j)) - ca(j)*dat0 - ((1-ca(j))*cmj*ivm)';
            p(m,j)=cp(j)*prod(skt(ker,cg,cl,cn));

        end
    end
end

p=p./(p*ones(nclus,nclus));