function [sal]=rmulti(N,p)

%Generates n random variates from a multinomial distribution (N,p)

ndis=size(p,1); nvars=size(p,2);

sal=zeros(size(p));

   

if nvars>1
    pr=p./(sum(p')'*ones(1,nvars));

    for l=1:ndis
        i=1; 
        nj=N; pj=pr(l,i); 
        rb=binornd(nj,pj); ss=rb;
        sal(l,i)=rb;
        nj=nj-rb;

        while nj>0
            i=i+1;
            pj=min(1,pr(l,i)/(1-sum(pr(l,1:i-1))));
            rb=binornd(nj,pj);
            sal(l,i)=rb;
            ss=rb+ss;
            nj=N-ss;
        end

    end
else
    sal=ones(size(p));
end