function [s]=sumtot(data,iv,indi,al,be,mu,ga,om)

%The basic quantity in the exponent

tt=size(data,1);  nvar=size(data,2);
dimi=size(indi); nclus=dimi(2);
tim=sum(1-isnan(data)); nobs=sum(tim);
runb=size(be,1); nvb=size(be,2);
runa=size(al,1); 
niv=size(iv,1); div=size(iv,3);
runm=size(mu,1); nkmu=size(mu,2); ncmu=size(mu,3);

if isequal(niv,ncmu)<1
    error('Length of mu is incorrect')
end
if isequal(nclus,size(al,2),nkmu)<1
    error('Clusters and parameters must agree')
end

ca=al(runa,:); cg=ga(length(ga));
cb=be(runb,:); cm=squeeze(mu(runm,:,:));

if isequal(nvar,nvb,dimi(1),div)<1
    error('The dimension of either beta, cov matrix or indi is not right')
end

ca=indi*ca';
if niv==1
    cm=indi*cm';
else
    cm=indi*cm;
end


s=zeros(1,nvar);

if isequal(nvar*tt,nobs)
    dat0=[zeros(1,nvar);data(1:tt-1,:)];
    cma=ones(tt,1)*ca';
    cbm=ones(tt,1)*cb;
    reg=NaN(tt,nvar);
    for i=1:nvar
        reg(:,i)=(cm(i,:)*squeeze(iv(:,:,i)))';
    end
    ker=data - cma.*dat0 - cbm.*(1-cma) - reg.*(1-cma);
    scl=(ker<=0)*cg + (ker>0)/cg;
    s=sum(om.*(ker.*scl).^2);
else
    for i=1:nvar
        whos=find(1-isnan(data(:,i)));
        dati=data(whos,i);
        dat0=[0;dati(1:tim(i)-1)];
        ker=dati-ca(i)*dat0-cb(i)*(1-ca(i)) - (((1-ca(i))*cm(i,:))*squeeze(iv(:,whos,i)))';
        scl= (ker<=0)*cg + (ker>0)/cg;
        s(i)=sum(om(whos,i).*(ker.*scl).^2);
    end
end
